<template>
    <div class="editProfile">
        <a class="backBtn" @click="onBack">
            <md-icon class="md-primary">chevron_left</md-icon>
            <span class="md-title">กลับ</span>
        </a>
        <h1>แก้ไขข้อมูลส่วนตัว</h1>
        <div class="editForm">
            <img src="https://placeimg.com/40/40/people/5" alt="people" class="profile">

            <md-field :class="usernameError">
                <label><md-icon>edit</md-icon>ชื่อผู้ใช้งาน</label>
                <md-input v-model="username"></md-input>
                <span class="md-error" v-if="usernameRequired">ต้องป้อนชื่อผู้ใช้ง่าน</span>
            </md-field>

            <md-field :class="emailError">
                <label><md-icon>edit</md-icon>อีเมลล์</label>
                <md-input v-model="email"></md-input>
                <span class="md-error" v-if="emailRequired">ต้องป้อนอีเมลล์</span>
                <span class="md-error" v-else-if="emailInvalid">รูปแบบอีเมลล์ไม่ถูกต้อง</span>
            </md-field> 

            <md-button class="md-raised md-primary editBtn" @click="editProfile">บันทึก</md-button>
        </div>

    </div>
</template>

<script>
export default {
    name: 'EditProfile',
    metaInfo: {
        title: 'แก้ไขข้อมูลส่วนตัว'
    },
    data() {
        return {
            username: 'Abbey Christansen',
            email: 'abbey.christ@gmail.com',
            usernameRequired: false,
            emailRequired: false,
            emailInvalid: false
        }
    },
    methods: {
        onBack() {
            this.$router.replace('/profile')
        },
        editProfile() {
            if(this.username === '') this.usernameRequired = true
            else this.usernameRequired = false

            if(this.email === '') this.emailRequired = true
            else this.emailRequired = false

            if(validationEmail(this.email) === false) this.emailInvalid = true
            else this.emailInvalid = false

            //Function for check email is valid
            function validationEmail(email) {
                const re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                return re.test(String(email).toLowerCase());
            }
        }
    },
    computed: {
        usernameError() {
            if(this.usernameRequired === true) return {'md-invalid': this.usernameRequired}
        },
        emailError() {
            if(this.emailRequired === true) return {'md-invalid': this.emailRequired}
            else if(this.emailInvalid) return {'md-invalid': this.emailInvalid}
        }
    }
}
</script>

<style lang="scss" scoped>
h1 {
    font-size: 2.5rem;
}

.backBtn {
    display: inline-flex;
    align-items: center;
}
.backBtn:hover {
    cursor: pointer;
    text-decoration: none;
}

.editForm {
    width: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}

.profile {
    width: 150px;
    height: 150px;
    border-radius: 10rem;
    margin: 1rem;
}

.editBtn {
    width: 100%;
    padding: 0;
    margin: 0;
    margin-top: 1rem;
}
</style>